#include<bits/stdc++.h>
using namespace std;
vector<long long> sus[100001];
long long pod[100001];
bool dali[100001];
long long dfs(long long wruh){
    long long kolko=0;
    for(long long i=0;i<sus[wruh].size();i++){
        kolko+=dfs(sus[wruh][i]);
    }
    pod[wruh]=kolko;
    return kolko+1;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    long long N,a,b;
    cin>>N;
    for(long long i=0;i<N-1;i++){
        cin>>a>>b;
        sus[a].push_back(b);
        dali[b]=1;
    }
    long long shef=1;
    for(long long i=1;i<=N;i++){
        if(!dali[i]){
            shef=i;
            break;
        }
    }
    dfs(shef);
    long long Q;
    cin>>Q;
    for(long long i=0;i<Q;i++){
        cin>>a;
        cout<<pod[a]<<"\n";
    }

    return 0;
}
